scala.tools.nsc.transform.patmat.ScalacPatternExpanders

# alignPatterns

###
Related Doc: package ScalacPatternExpanders

#### object alignPatterns extends ScalacPatternExpander

Source
  ScalacPatternExpanders.scala

Linear Supertypes
ScalacPatternExpander, PatternExpander[Global.Tree, Global.Type], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. alignPatterns
2. ScalacPatternExpander
3. PatternExpander
4. AnyRef
5. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### final case class Aligned(patterns: Patterns, extractor: Extractor) extends Product with Serializable

   If elementArity is...

   If elementArity is... 0: A perfect match between extractor and the fixed patterns. If there is a star pattern it will match any sequence. > 0: There are more patterns than products. There will have to be a sequence which can populate at least <elementArity> patterns. < 0: There are more products than patterns: compile time error.

   Definition Classes
     PatternExpander

2. #### final case class Extractor(whole: Type, fixed: List[Type], repeated: Repeated) extends Product with Serializable

   An 'extractor' can be a case class or an unapply or unapplySeq method.

   An 'extractor' can be a case class or an unapply or unapplySeq method. Decoding what it is that they extract takes place before we arrive here, so that this class can concentrate only on the relationship between patterns and types.

   In a case class, the class is the unextracted type and the fixed and repeated types are derived from its constructor parameters.

   In an unapply, this is reversed: the parameter to the unapply is the unextracted type, and the other types are derived based on the return type of the unapply method.

   In other words, this case class and unapply are encoded the same:

   case class Foo(x: Int, y: Int, zs: Char*) def unapplySeq(x: Foo): Option[(Int, Int, Seq[Char])]

   Both are Extractor(Foo, Int :: Int :: Nil, Repeated(Seq[Char], Char, Char*))

   whole

     The type in its unextracted form

   fixed

     The non-sequence types which are extracted

   repeated

     The sequence type which is extracted

   Definition Classes
     PatternExpander

3. #### final case class Patterns(fixed: List[Pattern], star: Pattern) extends Product with Serializable

   Definition Classes
     PatternExpander

4. #### sealed case class Repeated(sequenceType: Type, elementType: Type, repeatedType: Type) extends Product with Serializable

   It's not optimal that we're carrying both sequence and repeated type here, but the implementation requires more unraveling before it can be avoided.

   It's not optimal that we're carrying both sequence and repeated type here, but the implementation requires more unraveling before it can be avoided.

   sequenceType is Seq[T], elementType is T, repeatedType is T*.

   Definition Classes
     PatternExpander

5. #### final case class TypedPat(pat: Pattern, tpe: Type) extends Product with Serializable

   Definition Classes
     PatternExpander

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### def NoPattern: Global.EmptyTree.type

   You'll note we're not inside the cake.

   You'll note we're not inside the cake. "Pattern" and "Type" are arbitrary types here, and NoPattern and NoType arbitrary values.

   Definition Classes
     ScalacPatternExpander → PatternExpander

5. #### object NoRepeated extends Repeated

   Definition Classes
     PatternExpander

6. #### def NoType: Global.NoType.type

   Definition Classes
     ScalacPatternExpander → PatternExpander

7. #### def apply(context: (analyzer)#Context, tree: Global.Tree): Aligned

8. #### def apply(context: (analyzer)#Context, sel: Global.Tree, args: List[Global.Tree]): Aligned

9. #### def applyMethodTypes(method: Global.Type): Extractor

   In this case we are basing the pattern expansion on a case class constructor.

   In this case we are basing the pattern expansion on a case class constructor. The argument is the MethodType carried by the primary constructor.

   Definition Classes
     ScalacPatternExpander

10. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

11. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

12. #### def elementTypeOf(tpe: Global.Type): Global.Type

    Definition Classes
      ScalacPatternExpander

13. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

14. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

15. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

16. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

17. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### def newExtractor(whole: Global.Type, fixed: List[Global.Type], repeated: Repeated): Extractor

    Definition Classes
      ScalacPatternExpander

21. #### def newPatterns(patterns: List[Global.Tree]): Patterns

    Definition Classes
      ScalacPatternExpander

22. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

23. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### def repeatedFromSeq(seqType: Global.Type): Repeated

    Definition Classes
      ScalacPatternExpander

25. #### def repeatedFromVarargs(repeated: Global.Type): Repeated

    Definition Classes
      ScalacPatternExpander

26. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

27. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

28. #### def tupleExtractor(extractor: Extractor): Extractor

    Converts a T => (A, B, C) extractor to a T => ((A, B, CC)) extractor.

29. #### def unapplyMethodTypes(whole: Global.Type, result: Global.Type, isSeq: Boolean): Extractor

    In this case, expansion is based on an unapply or unapplySeq method.

    In this case, expansion is based on an unapply or unapplySeq method. Unfortunately the MethodType does not carry the information of whether it was unapplySeq, so we have to funnel that information in separately.

    Definition Classes
      ScalacPatternExpander

30. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

31. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

32. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from ScalacPatternExpander

### Inherited from PatternExpander[Global.Tree, Global.Type]

### Inherited from AnyRef

### Inherited from Any

### Ungrouped